#pragma once

#include "CoreMinimal.h"
#include "Presenter.h"
#include "UObject/SoftObjectPtr.h"
#include "EOverlayTabs.h"
#include "SettingsPresenter.generated.h"

class UUserWidget;
class USettingsMatchDetailsSubPresenter;
class USubPresenter;

UCLASS(Blueprintable, EditInlineNew)
class DBDUIPRESENTERS_API USettingsPresenter : public UPresenter
{
	GENERATED_BODY()

public:
	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	TSoftClassPtr<UUserWidget> SettingsWidgetClass;

private:
	UPROPERTY(EditAnywhere, BlueprintReadWrite, Transient, meta=(AllowPrivateAccess=true))
	USettingsMatchDetailsSubPresenter* _settingsMatchDetailsSubPresenter;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, Transient, meta=(AllowPrivateAccess=true))
	USubPresenter* _activeSubPresenter;

protected:
	UFUNCTION(BlueprintCallable)
	void OnTabEntered(const EOverlayTabs category);

public:
	USettingsPresenter();
};

FORCEINLINE uint32 GetTypeHash(const USettingsPresenter) { return 0; }
